// FormattedTitles.java   P. Conrad for H03, 06/25/2007
// University of Delaware, CISC370, 07J

// This class is in the "middle stages" of test-driven development
// for a class consisting of static methods for formatting titles.

// Your job is to determined what needs to be done to finish the job,
// and then, go ahead and finish the job.

// Hints: 
//   One of the methods already passes its tests.
//   Several other methods have tests written, but the implementations
//   are only stubs.
//   At least one JUnit test has a logic error in it (i.e. the test
//    itself is incorrect).
//   At least one method has no unit tests written yet.
//   There may be additional problems you have to fix, or this might
//     be all there is.

package edu.udel.cisc370.pconrad.Formats;

/**
 * FormattedTitles provides a set of static methods for formatting titles
 * in various ways. 
 *
 * @see <a href="http://www.udel.edu/CIS/370/pconrad/07J/hwk/H03.html">
 *      CISC370 07J Homework H03</a> 
 *
 * @author P. Conrad (instructor)
 * @author Fill_In_Your_Name_Here (student)
 * @author Fill_In_2nd_Students_Name_Here_If_Working_Together (student)
 */

public class FormattedTitles {


    /**
     * TitleWithBars is used, for example, to print a title with 
     * bars above and below it.
     *
     * <p>Example output of 
     * {@code System.out.print(FormattedTitles.TitleWithBars("foo","="));}</p>
     *
     * <pre>
     * ===
     * foo
     * ===
     * </pre>
     *
     * <p>Example output of 
     * {@code System.out.print(FormattedTitles.TitleWithBars("This is a test","-"));}</p>
     *
     * <pre>
     * --------------
     * This is a test
     * --------------
     * </pre>
     */

    public static String TitleWithBars(String title, String barChar) {
	
	// Note that replaceAll(".",barChar) replaces every character
	// (represented by the regular expression character "." with
	// the string represented by barChar

	return(
	       title.replaceAll(".",barChar) + "\n" + title + "\n"
	    + title.replaceAll(".",barChar) + "\n" );
    }
    
    /**
     * TitleInABox is used to bring a title in a box made
     * with the characters +, -, and |
     *
     * <p>Example output of 
     * {@code System.out.print(FormattedTitles.TitleInABox("foo"));}</p>
     * <pre>
     * +---+
     * |foo|
     * +---+
     * </pre>
     */

    public static String TitleInABox(String title) {
	

	return("thisIsAStub");

    }
    
    /**
     * CenteredTitle is used to print a title, centered in a certain
     * number of spaces
     *
     * <p>Example:</p>
     * <pre>
     *   System.out.println(FormattedTitles.CenteredTitle("foo",20));
     *   System.out.println("1234567890123457890");     
     * </pre>
     *
     * <p>Output:</p>
     * <pre>
     *         foo        
     * 12345678901234567890
     * </pre>
     *
     * <p><strong>Note:</strong> There is no trailing 
     *  <code>\n</code> in the result 
     *  of this method</p>
     */

    public static String CenteredTitle(String title,int width) {
	return("thisIsAStub");
    }

    /**
     * CenteredTitleInABox is used to produce a title in a box made
     * with the characters +, -, and |, centered in a field
     * of a certain width.   
     *
     * If there is an uneven number of spaces,
     * put the extra space after the title.
     *
     * <p>Example:</p>
     * <pre>
     *   System.out.print(FormattedTitles.CenteredTitleInABox("foo",20));
     *   System.out.println("1234567890123457890");     
     * </pre>
     *
     * <p>Output:</p>
     * <pre>
     *        +---+
     *        |foo|
     *        +---+
     * 12345678901234567890
     * </pre>
     *
     * <p><strong>Note:</strong> There <em>is</em> a trailing 
     *  <code>\n</code> in the result 
     *  of this method</p>
     */

    public static String CenteredTitleInABox(String title) {
	
	return("thisIsAStub");

    }


}














