// FormattedTitlesTest.java   P. Conrad for H03, 06/25/2007
// University of Delaware, CISC370, 07J

// This class is in the "middle stages" of test-driven development
// for a class consisting of static methods for formatting titles.

// Your job is to determined what needs to be done to finish the job,
// and then, go ahead and finish the job.

// Hints: 
//   One of the methods already passes its tests.
//   Several other methods have tests written, but the implementations
//   are only stubs.
//   At least one JUnit test has a logic error in it (i.e. the test
//    itself is incorrect).
//   At least one method has no unit tests written yet.
//   There may be additional problems you have to fix, or this might
//     be all there is.

package edu.udel.cisc370.pconrad.Formats;

import junit.framework.TestCase;

import edu.udel.cisc370.pconrad.Formats.FormattedTitles;

/**
 * Unit tests for the {@link FormattedTitles} class.
 *
 * @see <a href="http://www.udel.edu/CIS/370/pconrad/07J/hwk/H03.html">
 *      CISC370 07J Homework H03</a> 
 *
 * @author P. Conrad (instructor)
 * @author Fill_In_Your_Name_Here (student)
 * @author Fill_In_2nd_Students_Name_Here_If_Working_Together (student)
 */


public class FormattedTitlesTest extends TestCase {

    /**
     * Unit test for
     * {@link FormattedTitles#TitleWithBars TitleWithBars},
     * odd length title
     */

    public void testTitlesWithBars1() {
	String expected = 
	    "====\n" + 
	    "test\n" + 
	    "====\n";
	String actual = FormattedTitles.TitleWithBars("test","=");
	assertEquals(expected,actual);
    }

    /**
     * Unit test for
     * {@link FormattedTitles#TitleWithBars TitleWithBars},
     * even length title
     */

    public void testTitlesWithBars2() {
	String expected = 
	    "-----\n" + 
	    "check\n" + 
	    "-----\n";
	String actual = FormattedTitles.TitleWithBars("check","-");
	assertEquals(expected,actual);
    }

    /**
     * Unit test for
     * {@link FormattedTitles#TitleInABox TitleInABox},
     * odd length title.
     */

    public void testTitleInABox1() {
	String expected = 
	    "+---+\n" + 
	    "|foo|\n" + 
	    "+---+\n";
	String actual = FormattedTitles.TitleInABox("foo");
	assertEquals(expected,actual);
    }

    /**
     * Unit test for
     * {@link FormattedTitles#TitleInABox TitleInABox},
     * even length title.
     */

    public void testTitleInABox2() {
	String expected = 
	    "+----+\n" + 
	    "|test|\n" + 
	    "+----+\n";
	String actual = FormattedTitles.TitleInABox("test");
	assertEquals(expected,actual);
    }

    /**
     * Unit test for
     * {@link FormattedTitles#TitleInABox TitleInABox},
     * longer title with spaces.
     */

    public void testTitleInABox3() {
	String expected = 
	    "+----------------+\n" + 
	    "| This is a test |\n" + 
	    "+----------------+\n";
	String actual = FormattedTitles.TitleInABox(" foo ");
	assertEquals(expected,actual);
    }



    /**
     * Unit test for 
     * {@link FormattedTitles#CenteredTitle CenteredTitle},
     * odd length string, odd width.
     */

    public void testCenteredTitle1() {
	String expected = "   foo   ";
	final int width = 9;
	String actual = FormattedTitles.CenteredTitle("foo",width);
	assertEquals(expected,actual);
	
	assertEquals(width,expected.length());
	assertEquals(width,actual.length());
    }

    /**
     * Unit test for 
     * {@link FormattedTitles#CenteredTitle CenteredTitle},
     * odd length string, even width.
     */


    public void testCenteredTitle2() {
	String expected = "   foo    ";
	final int width = 10;
	String actual = FormattedTitles.CenteredTitle("foo",width);
	assertEquals(expected,actual);
	
	assertEquals(width,expected.length());
	assertEquals(width,actual.length());
    }

    /**
     * Unit test for 
     * {@link FormattedTitles#CenteredTitle CenteredTitle},
     * even length string, odd width.
     */

    public void testCenteredTitle3() {
	String expected = "  test   ";
	final int width = 9;
	String actual = FormattedTitles.CenteredTitle("test",width);
	assertEquals(expected,actual);
	
	assertEquals(width,expected.length());
	assertEquals(width,actual.length());
    }

    /**
     * Unit test for 
     * {@link FormattedTitles#CenteredTitle CenteredTitle},
     * even length string, even width.
     */

    public void testCenteredTitle4() {
	String expected = "   test   ";
	final int width = 10;
	String actual = FormattedTitles.CenteredTitle("test",width);
	assertEquals(expected,actual);
	
	assertEquals(width,expected.length());
	assertEquals(width,actual.length());
    }


} // class







